diff --git a/doc/guix.texi b/doc/guix.texi
index a72a726b54..d641935e0f 100644
--- a/doc/guix.texi
+++ b/doc/guix.texi
@@ -35555,9 +35555,9 @@ services)}.
 
 @node Essential Home Services
 @subsection Essential Home Services
-There are a few essential services defined in @code{(gnu
-home-services)}, they are mostly for internal use and are required to
-build a home environment, but some of them will be useful for the end
+There are a few essential home services defined in
+@code{(gnu services)}, they are mostly for internal use and are required
+to build a home environment, but some of them will be useful for the end
 user.
 
 @cindex environment variables
@@ -35810,7 +35810,7 @@ for example).
 @cindex mcron
 @cindex scheduling jobs
 
-The @code{(gnu home-services mcron)} module provides an interface to
+The @code{(gnu home services mcron)} module provides an interface to
 GNU@tie{}mcron, a daemon to run jobs at scheduled times (@pxref{Top,,,
 mcron, GNU@tie{}mcron}).  The information about system's mcron is
 applicable here (@pxref{Scheduled Job Execution}), the only difference
diff --git a/doc/he-config-bare-bones.scm b/doc/he-config-bare-bones.scm
index 01be46a7b0..1faf75b871 100644
--- a/doc/he-config-bare-bones.scm
+++ b/doc/he-config-bare-bones.scm
@@ -1,6 +1,6 @@
 (use-modules (gnu home)
              (gnu home-services)
-             (gnu home-services shells)
+             (gnu home services shells)
              (gnu services)
              (gnu packages admin)
              (guix gexp))
diff --git a/gnu/home-services.scm b/gnu/home-services.scm
index 9f1e986616..a244a15511 100644
--- a/gnu/home-services.scm
+++ b/gnu/home-services.scm
@@ -512,10 +512,10 @@ environment, and its configuration file, when available.")))
 
 (define %service-type-path
   ;; Search path for service types.
-  (make-parameter `((,%guix-home-root-directory . "gnu/home-services"))))
+  (make-parameter `((,%guix-home-root-directory . "gnu/home/services"))))
 
 (define (all-home-service-modules)
-  "Return the default set of home-service modules."
+  "Return the default set of `home service' modules."
   (cons (resolve-interface '(gnu home-services))
         (all-modules (%service-type-path)
                      #:warn warn-about-load-error)))
diff --git a/gnu/home.scm b/gnu/home.scm
index f4c9359e25..5ac382dc5a 100644
--- a/gnu/home.scm
+++ b/gnu/home.scm
@@ -18,10 +18,10 @@
 
 (define-module (gnu home)
   #:use-module (gnu home-services)
-  #:use-module (gnu home-services symlink-manager)
-  #:use-module (gnu home-services shells)
-  #:use-module (gnu home-services xdg)
-  #:use-module (gnu home-services fontutils)
+  #:use-module (gnu home services symlink-manager)
+  #:use-module (gnu home services shells)
+  #:use-module (gnu home services xdg)
+  #:use-module (gnu home services fontutils)
   #:use-module (gnu services)
   #:use-module (guix records)
   #:use-module (guix diagnostics)
diff --git a/gnu/home-services/configuration.scm b/gnu/home/services/configuration.scm
similarity index 98%
rename from gnu/home-services/configuration.scm
rename to gnu/home/services/configuration.scm
index e8f4bc77ec..5e7743e7d6 100644
--- a/gnu/home-services/configuration.scm
+++ b/gnu/home/services/configuration.scm
@@ -17,7 +17,7 @@
 ;;; You should have received a copy of the GNU General Public License
 ;;; along with GNU Guix.  If not, see <http://www.gnu.org/licenses/>.
 
-(define-module (gnu home-services configuration)
+(define-module (gnu home services configuration)
   #:use-module (gnu services configuration)
   #:use-module (guix gexp)
   #:use-module (srfi srfi-1)
diff --git a/gnu/home-services/fontutils.scm b/gnu/home/services/fontutils.scm
similarity index 98%
rename from gnu/home-services/fontutils.scm
rename to gnu/home/services/fontutils.scm
index 28bfc3d3f7..72a84fdecd 100644
--- a/gnu/home-services/fontutils.scm
+++ b/gnu/home/services/fontutils.scm
@@ -17,7 +17,7 @@
 ;;; You should have received a copy of the GNU General Public License
 ;;; along with GNU Guix.  If not, see <http://www.gnu.org/licenses/>.
 
-(define-module (gnu home-services fontutils)
+(define-module (gnu home services fontutils)
   #:use-module (gnu home-services)
   #:use-module (gnu packages fontutils)
   #:use-module (guix gexp)
diff --git a/gnu/home-services/mcron.scm b/gnu/home/services/mcron.scm
similarity index 98%
rename from gnu/home-services/mcron.scm
rename to gnu/home/services/mcron.scm
index fdfde179a5..cc6faac47f 100644
--- a/gnu/home-services/mcron.scm
+++ b/gnu/home/services/mcron.scm
@@ -17,11 +17,11 @@
 ;;; You should have received a copy of the GNU General Public License
 ;;; along with GNU Guix.  If not, see <http://www.gnu.org/licenses/>.
 
-(define-module (gnu home-services mcron)
+(define-module (gnu home services mcron)
   #:use-module (gnu packages guile-xyz)
   #:use-module (gnu home-services)
-  #:use-module (gnu home-services shepherd)
   #:use-module (gnu services shepherd)
+  #:use-module (gnu home services shepherd)
   #:use-module (guix records)
   #:use-module (guix gexp)
   #:use-module (srfi srfi-1)
diff --git a/gnu/home-services/shells.scm b/gnu/home/services/shells.scm
similarity index 99%
rename from gnu/home-services/shells.scm
rename to gnu/home/services/shells.scm
index ecb02098f7..2308371dd0 100644
--- a/gnu/home-services/shells.scm
+++ b/gnu/home/services/shells.scm
@@ -17,10 +17,10 @@
 ;;; You should have received a copy of the GNU General Public License
 ;;; along with GNU Guix.  If not, see <http://www.gnu.org/licenses/>.
 
-(define-module (gnu home-services shells)
+(define-module (gnu home services shells)
   #:use-module (gnu services configuration)
-  #:use-module (gnu home-services configuration)
-  #:use-module (gnu home-services utils)
+  #:use-module (gnu home services configuration)
+  #:use-module (gnu home services utils)
   #:use-module (gnu home-services)
   #:use-module (gnu packages shells)
   #:use-module (gnu packages bash)
diff --git a/gnu/home-services/shepherd.scm b/gnu/home/services/shepherd.scm
similarity index 99%
rename from gnu/home-services/shepherd.scm
rename to gnu/home/services/shepherd.scm
index 120cfde1a1..1a3e849bb2 100644
--- a/gnu/home-services/shepherd.scm
+++ b/gnu/home/services/shepherd.scm
@@ -17,7 +17,7 @@
 ;;; You should have received a copy of the GNU General Public License
 ;;; along with GNU Guix.  If not, see <http://www.gnu.org/licenses/>.
 
-(define-module (gnu home-services shepherd)
+(define-module (gnu home services shepherd)
   #:use-module (gnu home-services)
   #:use-module (gnu packages admin)
   #:use-module (gnu services shepherd)
diff --git a/gnu/home-services/symlink-manager.scm b/gnu/home/services/symlink-manager.scm
similarity index 99%
rename from gnu/home-services/symlink-manager.scm
rename to gnu/home/services/symlink-manager.scm
index 11f5d503d4..d53e8f5046 100644
--- a/gnu/home-services/symlink-manager.scm
+++ b/gnu/home/services/symlink-manager.scm
@@ -17,7 +17,7 @@
 ;;; You should have received a copy of the GNU General Public License
 ;;; along with GNU Guix.  If not, see <http://www.gnu.org/licenses/>.
 
-(define-module (gnu home-services symlink-manager)
+(define-module (gnu home services symlink-manager)
   #:use-module (gnu home-services)
   #:use-module (guix gexp)
 
diff --git a/gnu/home-services/utils.scm b/gnu/home/services/utils.scm
similarity index 98%
rename from gnu/home-services/utils.scm
rename to gnu/home/services/utils.scm
index f13133a7ae..cea75ee896 100644
--- a/gnu/home-services/utils.scm
+++ b/gnu/home/services/utils.scm
@@ -17,7 +17,7 @@
 ;;; You should have received a copy of the GNU General Public License
 ;;; along with GNU Guix.  If not, see <http://www.gnu.org/licenses/>.
 
-(define-module (gnu home-services utils)
+(define-module (gnu home services utils)
   #:use-module (ice-9 string-fun)
   #:use-module (srfi srfi-1)
   #:use-module (srfi srfi-26)
diff --git a/gnu/home-services/xdg.scm b/gnu/home/services/xdg.scm
similarity index 99%
rename from gnu/home-services/xdg.scm
rename to gnu/home/services/xdg.scm
index 94275f3b65..4aed9a5803 100644
--- a/gnu/home-services/xdg.scm
+++ b/gnu/home/services/xdg.scm
@@ -17,12 +17,12 @@
 ;;; You should have received a copy of the GNU General Public License
 ;;; along with GNU Guix.  If not, see <http://www.gnu.org/licenses/>.
 
-(define-module (gnu home-services xdg)
+(define-module (gnu home services xdg)
   #:use-module (gnu services configuration)
-  #:use-module (gnu home-services configuration)
+  #:use-module (gnu home services configuration)
   #:use-module (gnu home-services)
   #:use-module (gnu packages freedesktop)
-  #:use-module (gnu home-services utils)
+  #:use-module (gnu home services utils)
   #:use-module (guix gexp)
   #:use-module (guix records)
   #:use-module (guix i18n)
diff --git a/gnu/local.mk b/gnu/local.mk
index d415b892e9..5e8b769ce9 100644
--- a/gnu/local.mk
+++ b/gnu/local.mk
@@ -75,14 +75,14 @@ GNU_SYSTEM_MODULES =				\
   %D%/ci.scm					\
   %D%/home.scm					\
   %D%/home-services.scm			\
-  %D%/home-services/symlink-manager.scm	\
-  %D%/home-services/fontutils.scm		\
-  %D%/home-services/configuration.scm		\
-  %D%/home-services/shells.scm			\
-  %D%/home-services/shepherd.scm		\
-  %D%/home-services/mcron.scm			\
-  %D%/home-services/utils.scm			\
-  %D%/home-services/xdg.scm			\
+  %D%/home/services/symlink-manager.scm		\
+  %D%/home/services/fontutils.scm		\
+  %D%/home/services/configuration.scm		\
+  %D%/home/services/shells.scm			\
+  %D%/home/services/shepherd.scm		\
+  %D%/home/services/mcron.scm			\
+  %D%/home/services/utils.scm			\
+  %D%/home/services/xdg.scm			\
   %D%/image.scm					\
   %D%/packages.scm				\
   %D%/packages/abduco.scm			\
diff --git a/guix/scripts/home/import.scm b/guix/scripts/home/import.scm
index 79fb23a2fd..c977ec3861 100644
--- a/guix/scripts/home/import.scm
+++ b/guix/scripts/home/import.scm
@@ -41,7 +41,7 @@
   (let ((rc (string-append (getenv "HOME") "/.bashrc"))
         (profile (string-append (getenv "HOME") "/.bash_profile"))
         (logout (string-append (getenv "HOME") "/.bash_logout")))
-    `((gnu home-services bash)
+    `((gnu home services bash)
       (service home-bash-service-type
                  (home-bash-configuration
                   ,@(if (file-exists? rc)